//+------------------------------------------------------------------+
//|                                                 Chart_Equity.mq4 |
//|                                         Copyright  2009, Xupypr |
//|                              http://www.mql4.com/ru/users/Xupypr |
//|                                               10.06.2009 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Xupypr"
#property link      "http://www.mql4.com/ru/users/Xupypr"
#property show_inputs
#include <WinUser32.mqh>

extern string Only_Comment="";    //        ( [sl]  [tp])
extern string Only_Magics="";     //        (  )
extern string Only_Symbols="";    //     (  )
extern bool   Only_Current=false; //    
extern bool   Only_Buys=false;    //     
extern bool   Only_Sells=false;   //     
extern int    Start_Balance=0;    //       (0 -    )

datetime OpenTime_Ticket[][2]; //     
datetime CloseTime[];          //  
int      Type[];               //  
string   Instrument[];         // 
double   Lots[];               //  
double   OpenPrice[];          //  
double   ClosePrice[];         //  
double   Commission[];         // 
double   Swap[];               //  
double   CurSwap[];            //  
double   DaySwap[];            //  
double   Profit[];             //  
double   Magic[];              //  

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
 static bool open;
 static string minfosymbols="",m1symbols="";
 static double balance,equityopen,equityhigh,equitylow,equityclose;
 string filename;
 double spread,lotsize;
 int beginbar,bar,i,m,j,start,total,historytotal,opentotal,pos,unused[13];
 int timebar,exthandle=-1,handle=0;
 
 if (!IsConnected())
 {
  Print("     ");
  return(0);
 }
 if (Period()>PERIOD_D1)
 {
  Print("     D1"); 
  return(0);
 }
 if (!OrderSelect(0,SELECT_BY_POS,MODE_HISTORY))
 {
  Print("    -   "); 
  return(0);
 }
 historytotal=OrdersHistoryTotal();
 opentotal=OrdersTotal();
 total=historytotal+opentotal;
 ArrayResize(OpenTime_Ticket,total);
 for (i=0;i<historytotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
 {
  if (Select())
  {
   OpenTime_Ticket[i][0]=OrderOpenTime();
   OpenTime_Ticket[i][1]=OrderTicket();
  }
  else
  {
   OpenTime_Ticket[i][0]=EMPTY_VALUE;
   total--;
  }
 }
 if (opentotal>0)
 {
  for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
  {
   if (Select())
   {
    OpenTime_Ticket[historytotal+i][0]=OrderOpenTime();
    OpenTime_Ticket[historytotal+i][1]=OrderTicket();
   }
   else
   {
    OpenTime_Ticket[historytotal+i][0]=EMPTY_VALUE;
    total--;
   }
  }
 }
 ArraySort(OpenTime_Ticket);
 ArrayResize(OpenTime_Ticket,total);
 ArrayResize(CloseTime,total);
 ArrayResize(Type,total);
 ArrayResize(Lots,total);
 ArrayResize(Instrument,total);
 ArrayResize(OpenPrice,total);
 ArrayResize(ClosePrice,total);
 ArrayResize(Commission,total);
 ArrayResize(Swap,total);
 ArrayResize(CurSwap,total);
 ArrayResize(DaySwap,total);
 ArrayResize(Profit,total);
 ArrayResize(Magic,total);
 for (i=0;i<total;i++) if (OrderSelect(OpenTime_Ticket[i][1],SELECT_BY_TICKET)) ReadOrder(i);
 if (Type[0]<6)
 {
  Print("    ");
  return(0);
 }
 exthandle=FileOpenHistory("!Equity"+Period()+".hst",FILE_BIN|FILE_WRITE);
 if (exthandle<0) return(0);
 FileWriteInteger(exthandle,400,LONG_VALUE);
 FileWriteString(exthandle,"(C)opyright 2003, MetaQuotes Software Corp.",64);
 FileWriteString(exthandle,"!Equity",12);
 FileWriteInteger(exthandle,Period(),LONG_VALUE);
 FileWriteInteger(exthandle,2,LONG_VALUE);
 FileWriteInteger(exthandle,0,LONG_VALUE);
 FileWriteInteger(exthandle,0,LONG_VALUE);
 FileWriteArray(exthandle,unused,0,13);
 start=0;
 balance=0.0;
 beginbar=iBarShift(NULL,0,OpenTime_Ticket[0][0]);
 for (i=beginbar;i>=0;i--)
 {
  open=true;
  equityopen=0.0;
  timebar=iTime(NULL,0,i);
  for (m=0;m<Period();m++)
  {
   if (timebar>TimeCurrent()) break;
   equityclose=0.0;
   for (j=start;j<total;j++)
   {
    if (OpenTime_Ticket[j][0]>timebar+60) break;
    if (CloseTime[start]<timebar) start++;
    if (CloseTime[j]>=timebar && CloseTime[j]<timebar+60 && Type[j]>5)
    {
     balance+=Profit[j];
     if (i==beginbar)
     {
      if (Start_Balance!=0) balance=Start_Balance;
      open=true;
     }
     continue;
    }
    if (CloseTime[j]>=timebar && CloseTime[j]<timebar+60 && ClosePrice[j]!=0) balance+=Swap[j]+Commission[j]+Profit[j];
    else if (OpenTime_Ticket[j][0]<=timebar && CloseTime[j]>=timebar)
    {
     if (MarketInfo(Instrument[j],MODE_POINT)==0)
     {
      if (StringFind(minfosymbols,Instrument[j])==-1)
      {
       Print("     "+Instrument[j]);
       minfosymbols=StringConcatenate(minfosymbols," ",Instrument[j]);
      }
      continue;
     }
     bar=iBarShift(Instrument[j],PERIOD_M1,timebar);
     if (iTime(Instrument[j],PERIOD_M1,bar)>timebar+300)
     {
      if (StringFind(m1symbols,Instrument[j])==-1)
      {
       Print("  M1  "+Instrument[j]+"   "+TimeToStr(iTime(Instrument[j],PERIOD_M1,bar)));
       m1symbols=StringConcatenate(m1symbols," ",Instrument[j]);
      }
      continue;
     }
     if (open)
     {
      if (TimeDayOfWeek(iTime(NULL,0,i))!=TimeDayOfWeek(iTime(NULL,0,i+1)) && OpenTime_Ticket[j][0]<timebar)
      {
       switch (MarketInfo(Instrument[j],MODE_PROFITCALCMODE))
       {
        case 0:
        {
         if (TimeDayOfWeek(iTime(NULL,0,i))==4) CurSwap[j]+=3*DaySwap[j];
         else CurSwap[j]+=DaySwap[j];
        } break;
        case 1:
        {
         if (TimeDayOfWeek(iTime(NULL,0,i))==1) CurSwap[j]+=3*DaySwap[j];
         else CurSwap[j]+=DaySwap[j];
        }
       }
      }
      if (Type[j]==OP_BUY)
      {
       lotsize=LotSize(Instrument[j],timebar,false);
       equityopen+=Commission[j]+CurSwap[j]+(iOpen(Instrument[j],PERIOD_M1,bar)-OpenPrice[j])*Lots[j]*lotsize;
      }
      else
      {
       spread=MarketInfo(Instrument[j],MODE_POINT)*MarketInfo(Instrument[j],MODE_SPREAD);
       lotsize=LotSize(Instrument[j],timebar,false);
       equityopen+=Commission[j]+CurSwap[j]+(OpenPrice[j]-iOpen(Instrument[j],PERIOD_M1,bar)-spread)*Lots[j]*lotsize;
      }
     }
     if (Type[j]==OP_BUY)
     {
      lotsize=LotSize(Instrument[j],timebar,true);
      equityclose+=Commission[j]+CurSwap[j]+(iClose(Instrument[j],PERIOD_M1,bar)-OpenPrice[j])*Lots[j]*lotsize;
     }
     else
     {
      spread=MarketInfo(Instrument[j],MODE_POINT)*MarketInfo(Instrument[j],MODE_SPREAD);
      lotsize=LotSize(Instrument[j],timebar,true);
      equityclose+=Commission[j]+CurSwap[j]+(OpenPrice[j]-iClose(Instrument[j],PERIOD_M1,bar)-spread)*Lots[j]*lotsize;
     }
    }
   }
   timebar+=60;
   if (open)
   {
    equityopen+=balance;
    equityhigh=equityopen;
    equitylow=equityopen;
    open=false;
   }
   equityclose+=balance;
   if (equityhigh<equityclose) equityhigh=equityclose;
   if (equitylow>equityclose)  equitylow=equityclose;
  }
  pos=FileTell(exthandle);
  FileWriteInteger(exthandle,iTime(NULL,0,i),LONG_VALUE);
  FileWriteDouble(exthandle,equityopen,DOUBLE_VALUE);
  FileWriteDouble(exthandle,equitylow,DOUBLE_VALUE);
  FileWriteDouble(exthandle,equityhigh,DOUBLE_VALUE);
  FileWriteDouble(exthandle,equityclose,DOUBLE_VALUE);
  FileWriteDouble(exthandle,equityhigh-equitylow,DOUBLE_VALUE);
 }
 FileFlush(exthandle);
 Print("  !Equity"+Period()+".hst: "+FileSize(exthandle)+" ");
 timebar=Time[0];
 ArrayResize(OpenTime_Ticket,opentotal);
 if (opentotal>0)
 {
  for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) OpenTime_Ticket[i][1]=OrderTicket();
 }
 while (IsStopped()==false)
 {
  Sleep(500);
  if (RefreshRates())
  {
   if (timebar!=Time[0])
   {
    pos=FileTell(exthandle);
    timebar=Time[0];
    equityopen=0.0;
    equityclose=0.0;
    open=true;
   }
   FileSeek(exthandle,pos,SEEK_SET);
   if (Only_Comment=="" && Only_Magics=="" && Only_Symbols=="" && !Only_Current && !Only_Buys && !Only_Sells)
   {
    if (open)
    {
     equityopen=AccountEquity();
     equityhigh=equityopen;
     equitylow=equityopen;
     open=false;
    }
    equityclose=AccountEquity();
    if (equityclose<equitylow)  equitylow=equityclose;
    if (equityclose>equityhigh) equityhigh=equityclose;
   }
   else
   {
    opentotal=ArraySize(OpenTime_Ticket);
    if (opentotal>0)
    {
     for (i=0;i<opentotal;i++)
     {
      if (!OrderSelect(OpenTime_Ticket[i][1],SELECT_BY_TICKET)) continue;
      if (OrderCloseTime()==0) continue;
      else if (Select()) balance+=OrderCommission()+OrderSwap()+OrderProfit();
     }
    }
    equityclose=0.0;
    opentotal=OrdersTotal();
    if (opentotal>0)
    {
     for (i=0;i<opentotal;i++)
     {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (Select()) equityclose+=OrderCommission()+OrderSwap()+OrderProfit();
     }
    }
    equityclose+=balance;
    if (open)
    {
     equityopen=equityclose;
     equitylow=equityopen;
     equityhigh=equityopen;
     open=false;
    }
    if (equityclose<equitylow)  equitylow=equityclose;
    if (equityclose>equityhigh) equityhigh=equityclose;
    ArrayResize(OpenTime_Ticket,opentotal);
    if (opentotal>0)
    {
     for (i=0;i<opentotal;i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) OpenTime_Ticket[i][1]=OrderTicket();
    }
   }
   FileWriteInteger(exthandle,timebar,LONG_VALUE);
   FileWriteDouble(exthandle,equityopen,DOUBLE_VALUE);
   FileWriteDouble(exthandle,equitylow,DOUBLE_VALUE);
   FileWriteDouble(exthandle,equityhigh,DOUBLE_VALUE);
   FileWriteDouble(exthandle,equityclose,DOUBLE_VALUE);
   FileWriteDouble(exthandle,equityhigh-equitylow,DOUBLE_VALUE);
   if (handle==0)
   {
    handle=WindowHandle("!Equity",Period());
    if (handle!=0) Print("   -  ");
   }
   else
   {
    handle=WindowHandle("!Equity",Period());
    if (handle!=0) PostMessageA(handle,WM_COMMAND,33324,0);
    else Print("  ");
   }
  }
 }
 FileClose(exthandle);
 return(0);
}
//+----------------------------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------------------------+
void ReadOrder(int n)
{
 Type[n]=OrderType();
 if (OrderType()>5) Instrument[n]=OrderComment();
 else Instrument[n]=OrderSymbol();
 Lots[n]=OrderLots();
 OpenPrice[n]=OrderOpenPrice();
 int close;
 if (OrderCloseTime()!=0)
 {
  CloseTime[n]=OrderCloseTime();
  ClosePrice[n]=OrderClosePrice();
  close=iBarShift(NULL,0,OrderCloseTime());
 }
 else
 {
  CloseTime[n]=TimeCurrent();
  ClosePrice[n]=0.0;
  close=0;
 }
 Commission[n]=OrderCommission();
 Swap[n]=OrderSwap();
 Profit[n]=OrderProfit();
 CurSwap[n]=0.0;
 int swapdays=0;
 int open=iBarShift(NULL,0,OrderOpenTime());
 for (int b=open-1;b>=close;b--)
 {
  if (TimeDayOfWeek(iTime(NULL,0,b))!=TimeDayOfWeek(iTime(NULL,0,b+1)))
  {
   switch (MarketInfo(Instrument[n],MODE_PROFITCALCMODE))
   {
    case 0:
    {
     if (TimeDayOfWeek(iTime(NULL,0,b))==4) swapdays+=3;
     else swapdays++;
    } break;
    case 1:
    {
     if (TimeDayOfWeek(iTime(NULL,0,b))==1) swapdays+=3;
     else swapdays++;
    }
   }
  }
 }
 if (swapdays>0) DaySwap[n]=Swap[n]/swapdays; else DaySwap[n]=0.0;
 Magic[n]=OrderMagicNumber();
 if (Lots[n]==0)
 {
  string ticket=StringSubstr(OrderComment(),StringFind(OrderComment(),"#")+1);
  if (OrderSelect(StrToInteger(ticket),SELECT_BY_TICKET,MODE_HISTORY)) Lots[n]=OrderLots();
 }
}
//+----------------------------------------------------------------------------+
//|                                                 |
//+----------------------------------------------------------------------------+
double LotSize(string symbol, datetime tbar, bool close)
{
 double size;
 string BQ,currency=AccountCurrency();
 switch (MarketInfo(symbol,MODE_PROFITCALCMODE))
 {
  case 0:
  {
   int sbar=iBarShift(symbol,PERIOD_M1,tbar);
   size=MarketInfo(symbol,MODE_LOTSIZE);
   if (StringSubstr(symbol,3,3)=="USD") break;
   if (StringSubstr(symbol,0,3)=="USD")
   {
    if (close) size=size/iClose(symbol,PERIOD_M1,sbar);
    else size=size/iOpen(symbol,PERIOD_M1,sbar);
   }
   else
   {
    BQ=StringSubstr(symbol,0,3)+"USD";
    if (iClose(BQ,PERIOD_M1,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
    if (iClose(BQ,PERIOD_M1,0)==0) break;
    int BQbar=iBarShift(BQ,PERIOD_M1,tbar);
    if (StringSubstr(BQ,0,3)=="USD")
    {
     if (close) size=size/iClose(BQ,PERIOD_M1,BQbar)/iClose(symbol,PERIOD_M1,sbar);
     else size=size/iOpen(BQ,PERIOD_M1,BQbar)/iOpen(symbol,PERIOD_M1,sbar);
    }
    else
    {
     if (close) size=size*iClose(BQ,PERIOD_M1,BQbar)/iClose(symbol,PERIOD_M1,sbar);
     else size=size*iOpen(BQ,PERIOD_M1,BQbar)/iOpen(symbol,PERIOD_M1,sbar);
    }
   }
  } break;
  case 1: size=MarketInfo(symbol,MODE_LOTSIZE); break;
  case 2: size=MarketInfo(symbol,MODE_TICKVALUE)/MarketInfo(symbol,MODE_TICKSIZE);
 }
 if (currency!="USD")
 {
  BQ=currency+"USD";
  if (iClose(BQ,PERIOD_M1,0)==0)
  {
   BQ="USD"+currency;
   if (close) size*=iClose(BQ,PERIOD_M1,iBarShift(BQ,PERIOD_M1,tbar));
   else size*=iOpen(BQ,PERIOD_M1,iBarShift(BQ,PERIOD_M1,tbar));
  }
  else
  {
   if (close) size/=iClose(BQ,PERIOD_M1,iBarShift(BQ,PERIOD_M1,tbar));
   else size/=iOpen(BQ,PERIOD_M1,iBarShift(BQ,PERIOD_M1,tbar));
  }
 }
 return(size);
}
//+----------------------------------------------------------------------------+
//|                                                      |
//+----------------------------------------------------------------------------+
bool Select()
{
 if (OrderType()>5) return(true);
 if (OrderType()>1) return(false);
 if (Only_Comment!="")
 {
  if (StringFind(OrderComment(),Only_Comment)==-1) return(false);
 }
 if (Only_Magics!="")
 {
  if (StringFind(Only_Magics,DoubleToStr(OrderMagicNumber(),0))==-1) return(false);
 }
 if (Only_Symbols!="")
 {
  if (StringFind(Only_Symbols,OrderSymbol())==-1) return(false);
 }
 else if (Only_Current && OrderSymbol()!=Symbol()) return(false);
 if (Only_Buys && OrderType()!=OP_BUY) return(false);
 if (Only_Sells && OrderType()!=OP_SELL) return(false);
 return(true);
}
//+------------------------------------------------------------------+